## APMonitor Challenge Problem ##
## Solution by Trent Okeson    ##

from apm import *
import matplotlib.pyplot as plt
import numpy as np

s = 'http://byu.apmonitor.com'
a = 'challenge_problem_trent'

apm(s, a, 'clear all')
apm_load(s, a, 'model.apm')
csv_load(s, a, 'data.csv')

apm_option(s, a, 'nlc.imode', 6)
apm_option(s, a, 'nlc.nodes', 4)
apm_option(s, a, 'nlc.solver', 3)

apm_info(s, a, 'MV', 'u')
apm_info(s, a, 'FV', 'ts')
apm_option(s, a, 'u.status', 1)
apm_option(s, a, 'ts.status', 1)

output = apm(s, a, 'solve')
print output

y = apm_sol(s, a)

print('The final conditions for x and y are {:.2f} and {:.2f} respectively.'.format(y['x'][-1], y['y'][-1]))

# create a time vector scaled by tf
ts = y['ts'][0]
time = np.zeros(len(y['time']))
yn = np.zeros(len(y['y']))
for i in range(len(time)):
    time[i] = y['time'][i] * ts
    yn[i] = -y['y'][i]

plt.figure(1)
plt.subplot(3,1,1)
plt.plot(y['x'], yn, 'r-',linewidth=3)
plt.axis([0,2,-2,0])
plt.xlabel('Position (x)')
plt.ylabel('Position (-y)')
plt.subplot(3,1,2)
plt.plot(time, y['u'], 'b--',linewidth=2)
plt.ylabel('Angle')
plt.xlabel('Time')
plt.subplot(3,1,3)
plt.plot(time, y['v'], 'g:',linewidth=2)
plt.ylabel('Velocity')
plt.xlabel('Time')
plt.savefig('solution.png', format='png')

plt.show()
